/*
Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"),
to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense,
and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

  Compan:PSCUFS
  Description: Component wrapping the calls made to seam remoting. 
  Author: Cameron Ingram
  Version: 1.0
*/
package com.pscufs.flex.actionscript.bridge
{

	import flash.external.ExternalInterface;
	import bridge.FABridge;

	public class SeamBridge	{
		
		//Constant name of the method to call on the javascript side
		private static var JAVASCRIPT_METHOD: String = "callServer";
		
		//Name of the seam component to be called(i.e @Name)
		private var seamComponent: String;
		
		//The method of the seam component to invoke.
		private var method: String;
		
		//The method that the server should return to when finished processing.
		private var callBackMethod: String;
		
		//The params needed for the method.
		private var params: Array;
		
		
		function SeamBridge() {
			params = new Array();
		}
		

		
		public function addParam(param: Object) : void {
			if (params.length == 0) {
				params[0] = param;
			} else {
				param[length+1] = param;
			}
		}
		
		//Calls the server, duh... Should be invoked after every thing is set.
		//Clear the params after bieng called.
		//TODO: add exception handeling incase the properties havent been set.
		public function callServer(): void {
			ExternalInterface.call(JAVASCRIPT_METHOD,seamComponent,method,params, callBackMethod);
			clearParams();
		}
		
		//TODO: Replace with the proper action script syntax to do the same thing
		public function setSeamComponent(seamComponent: String) : void {
			this.seamComponent = seamComponent;
		}
		
   	    //TODO: Replace with the proper action script syntax to do the same thing
		public function setMethod(method: String) : void {
			this.method = method;
		}
		
    	//TODO: Replace with the proper action script syntax to do the same thing
		public function setCallBackMethod(callBackMethod: String): void {
			this.callBackMethod = callBackMethod;
		}
		
		//Clear the params.
		private function clearParams() : void {
  		    params = null;
			params = new Array();
		}
	}
}